<?php

function fix_newlines_for_clean_html($fixthistext) {                            //Function to seperate multiple tags one line
    $fixthistext_array = explode("\n", $fixthistext);
    foreach ($fixthistext_array as $unfixedtextkey => $unfixedtextvalue) {      //Makes sure empty lines are ignores
        if (!preg_match("/^(\s)*$/", $unfixedtextvalue)) {
            $fixedtextvalue = preg_replace("/>(\s|\t)*</U", ">\n<", $unfixedtextvalue);
            $fixedtext_array[$unfixedtextkey] = $fixedtextvalue;
        }
    }
    return implode("\n", $fixedtext_array);
}

function clean_html_code($uncleanhtml) {
    $indent = "    ";                                                           //Set wanted indentation
    $fixed_uncleanhtml = fix_newlines_for_clean_html($uncleanhtml);             //Uses previous function to seperate tags
    $uncleanhtml_array = explode("\n", $fixed_uncleanhtml);
    $indentlevel = 0;                                                           //Sets no indentation
    foreach ($uncleanhtml_array as $uncleanhtml_key => $currentuncleanhtml) {   //Removes all indentation
        $currentuncleanhtml = preg_replace("/\t+/", "", $currentuncleanhtml);
        $currentuncleanhtml = preg_replace("/^\s+/", "", $currentuncleanhtml);

        $replaceindent = "";

        for ($o = 0; $o < $indentlevel; $o++) {                                 //Sets the indentation from current indentlevel
            $replaceindent .= $indent;
        }

        if (preg_match("/<(.+)\/>/", $currentuncleanhtml)) {                    //If self-closing tag, simply apply indent
            $cleanhtml_array[$uncleanhtml_key] = $replaceindent.$currentuncleanhtml;
        } elseif (preg_match("/<!(.*)>/", $currentuncleanhtml)) {               //If doctype declaration, simply apply indent
            $cleanhtml_array[$uncleanhtml_key] = $replaceindent.$currentuncleanhtml;
        } elseif (preg_match("/<[^\/](.*)>/", $currentuncleanhtml)
                && preg_match("/<\/(.*)>/", $currentuncleanhtml)
            ) {                                                                 //If opening AND closing tag on same line, simply apply indent
            $cleanhtml_array[$uncleanhtml_key] = $replaceindent.$currentuncleanhtml;
        } elseif (preg_match("/<\/(.*)>/", $currentuncleanhtml)
                || preg_match("/^(\s|\t)*\}{1}(\s|\t)*$/", $currentuncleanhtml)
            ) {                                                                 //If closing HTML tag or closing JavaScript clams, decrease indentation and then apply the new level
            $indentlevel--;
            $replaceindent = "";
            for ($o = 0; $o < $indentlevel; $o++) {
                $replaceindent .= $indent;
            }
            if($currentuncleanhtml == '</textarea>' || $currentuncleanhtml == '</script>') { // fix for textarea whitespace and in my opinion nicer looking script tags
                $cleanhtml_array[$uncleanhtml_key] = $cleanhtml_array[($uncleanhtml_key - 1)] . $currentuncleanhtml;
                unset($cleanhtml_array[($uncleanhtml_key - 1)]);
            } else {
                $cleanhtml_array[$uncleanhtml_key] = $replaceindent.$currentuncleanhtml;
            }
        } elseif ((preg_match("/<[^\/](.*)>/", $currentuncleanhtml)
                && !preg_match("/<(link|meta|base|br|img|hr)(.*)>/", $currentuncleanhtml))
                || preg_match("/^(\s|\t)*\{{1}(\s|\t)*$/", $currentuncleanhtml)
            ) {                                                                 //If opening HTML tag AND not a stand-alone tag, or opening JavaScript clams, increase indentation and then apply new level
            $cleanhtml_array[$uncleanhtml_key] = $replaceindent.$currentuncleanhtml;
            $indentlevel++;
            $replaceindent = "";
            for ($o = 0; $o < $indentlevel; $o++) {
                $replaceindent .= $indent;
            }
        } else {                                                                //Else, only apply indentation
            $cleanhtml_array[$uncleanhtml_key] = $replaceindent.$currentuncleanhtml;
        }
    }
    return str_repeat(" ", 8) . implode("\n" . str_repeat(" ", 8), $cleanhtml_array);                                     //Return single string seperated by newline
}
?>
