<?php

session_start();
// WORK INIT BEGIN
// $_SESSION['userID']       = 44;
// $_SESSION['userMail']     = 'webmaster@d0n.be';
// $_SESSION['userLanguage'] = 'FR';
//unset($_SESSION['userID']);
// WORK INIT END
// if ($_SERVER['REQUEST_METHOD'] == 'POST') {
//     $_SESSION['postdata'] = $_POST;
//     unset($_POST);
//     header("Location: ".$_SERVER['PHP_SELF']);
//     exit;
// }

if (!file_exists( __DIR__ . '/includes/config.php')) {   
    require_once __DIR__ . '/install/index.php';
    die();
}
include "includes/config.php";
include "includes/locales.php";
include "includes/functions.php";

if (isset($_GET['logout'])) {
    $_SESSION = array();
    if (session_status() === PHP_SESSION_ACTIVE) {
        session_destroy();
    }
    echo '<script>window.location.href="index.php";</script>';
}
if (isset($_GET['person_id'])) {
    $_SESSION['person_id'] = $_GET['person_id'];
} elseif (!isset($_SESSION['person_id'])) {
    $_SESSION['person_id'] = 0;
}
if (isset($_GET['lang'])) {
    $_SESSION['lang'] = $_GET['lang'];
} elseif (!isset($_SESSION['lang'])) {
    $_SESSION['lang'] = 'FR';
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"/>
    <title><?php echo $site_name; ?></title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
    <!-- Home screen icon name for IOS and Android -->
    <meta name="apple-mobile-web-app-title" content="2myRoots">
    <!-- Home screen icon name for Windows -->
    <meta name="application-name" content="2myRoots">
    <!-- Live Tile for Windows -->
    <meta name="msapplication-TileColor" content="#FF0000">
    <meta name="msapplication-badge" content="frequency=60;polling-uri=http://host/ badge.xml">
    <meta name="msapplication-notification" content="frequency=30;polling-uri=http://host/ live.xml">
    <meta name="msapplication-square70x70logo" content="template/images/small.jpg"/>
    <meta name="msapplication-square150x150logo" content="template/images/medium.jpg"/>
    <meta name="msapplication-wide310x150logo" content="template/images/wide.jpg"/>
    <meta name="msapplication-square310x310logo" content="template/images/large.jpg"/>
    <!-- for ios 7 style, multi-resolution icon of 152x152 -->
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-barstyle" content="black-translucent">
    <link rel="apple-touch-icon" href="template/images/icon-152.png">
    <!-- for Chrome on Android, multi-resolution icon of 196x196 -->
    <meta name="mobile-web-app-capable" content="yes">
    <link rel="shortcut icon" sizes="196x196" href="template/images/icon-196.png">
<?php
$today  = new DateTime();
$spring = new DateTime('March 20');
$summer = new DateTime('June 20');
$fall   = new DateTime('September 22');
$winter = new DateTime('December 21');
echo '    <style type="text/css">body { background: url(\'template/images/';
switch (true) {
    case $today >= $spring && $today < $summer:
        echo 'spring.jpg';
        break;
    case $today >= $summer && $today < $fall:
        echo 'summer.jpg';
        break;
    case $today >= $fall && $today < $winter:
        echo 'fall.jpg';
        break;
    default:
        echo 'winter.jpg';
}
echo '\');}</style>
';
?>
    <link href="template/radiochk.css" rel="stylesheet">
    <link href="template/style.css" rel="stylesheet">
    <link href="template/menu.css" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
    <script src="https://www.google.com/recaptcha/api.js?hl=<?php echo $_SESSION['lang']; ?>" async defer></script>
    <script type='text/javascript' src='includes/autocomplete.js'></script>    
</head>
<body>
<?php
include "contents/header.php";
echo '
    <div class="container">
    ';
    if (isset($_GET['page'])) {
        if ($_GET['page'] == 'tree') {
            include "contents/tree.php";
        } else {
            echo '
            <div class="boxes">
            ';
            include "contents/" . $_GET['page'] . ".php";
            echo '

            </div>';        
        }
    } else {
        include "contents/kinship.php";
        echo '
        <div class="boxes">
        ';
        if (isset($_SESSION['userID'])) {
            if ($_SESSION['person_id'] > 0) {
                include "contents/card.php";
                include "contents/events.php";
                include "contents/medias.php";
            } else {
                include "contents/howto.php";
            }
        } else {
            include "contents/howto.php";
        }
        echo '
        
        </div>';
    }
echo '

    </div>
';
include "contents/footer.php";
?>

    <script><?php
    if (isset($_SESSION['userID'])) {
        $sel = "    
            SELECT      person_id, CONCAT(person_first_name, ' ', person_last_name) 
            FROM        2mr_persons 
            ORDER BY    person_first_name, person_last_name
            ";
    } else {
        $sel = "    
            SELECT      person_id, CONCAT(person_first_name, ' ', person_last_name) 
            FROM        2mr_persons 
            LEFT JOIN   2mr_events USING(person_id)
            WHERE       event_type = 'D' 
                    AND event_date < '" . date('Y-m-d', strtotime("-50 year", time())) . "'
            ORDER BY    person_first_name, person_last_name
            ";
        }
    $qry = mysqli_query($link, $sel);
    while ($row = mysqli_fetch_array($qry)) {
        $people_name[] = $row[1];
        $people_id[$row[1]] = $row[0];
    }
    $tmp = json_encode($people_name);
    echo "
        var names = " . $tmp . ";";
    $tmp = json_encode($people_id);
    echo "
        var ids = " . $tmp . ";";
    if (!isset($_GET['page']) || !in_array($_GET['page'],['admin','choices','login','signup'])) {
        echo '    
        autocomplete(document.getElementById("kinship"), names);
';
    }
    ?>
        autocomplete(document.getElementById("father"), names);
        autocomplete(document.getElementById("mother"), names);
        autocomplete(document.getElementById("event_reason"), names);
    </script>

</body>
</html>
