SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";
CREATE TABLE 2mr_admins (
  user_id smallint(6) NOT NULL,
  user_name varchar(20) NOT NULL DEFAULT '',
  user_password varchar(32) NOT NULL DEFAULT '',
  user_email varchar(128) NOT NULL DEFAULT '',
  user_language varchar(2) NOT NULL,
  user_admin enum('Y','N') NOT NULL DEFAULT 'N',
  user_edit enum('Y','N') NOT NULL DEFAULT 'N',
  user_style varchar(40) NOT NULL DEFAULT '',
  updated_on date NOT NULL,
  updated_by varchar(20) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TABLE 2mr_events (
  event_id smallint(5) NOT NULL,
  person_id smallint(5) NOT NULL,
  event_type varchar(1) NOT NULL,
  event_date date NOT NULL,
  event_certif enum('Y','N') NOT NULL DEFAULT 'N',
  event_place varchar(20) NOT NULL,
  event_reason varchar(20) NOT NULL,
  event_note varchar(255) NOT NULL,
  updated_on date NOT NULL,
  updated_by varchar(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
CREATE TABLE 2mr_medias (
  media_id smallint(5) NOT NULL,
  person_id smallint(5) NOT NULL,
  media_type enum('A','C','P') NOT NULL,
  media_title varchar(20) NOT NULL,
  media_file varchar(20) NOT NULL,
  media_date date NOT NULL,
  media_descr varchar(255) NOT NULL,
  updated_on date NOT NULL,
  updated_by varchar(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
CREATE TABLE 2mr_persons (
  person_id smallint(5) NOT NULL,
  person_last_name varchar(20) NOT NULL,
  person_first_name varchar(20) NOT NULL,
  person_suffix varchar(10) NOT NULL,
  person_gender enum('M','F') NOT NULL,
  person_mother_id smallint(5) NOT NULL,
  person_father_id smallint(5) NOT NULL,
  updated_on date NOT NULL,
  updated_by varchar(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
CREATE TABLE 2mr_trackings (
  person_id smallint(5) UNSIGNED ZEROFILL NOT NULL DEFAULT 00000,
  user_email varchar(128) NOT NULL DEFAULT '',
  tracking_expires date DEFAULT NULL,
  updated_on date DEFAULT NULL,
  updated_by varchar(20) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
ALTER TABLE 2mr_admins ADD PRIMARY KEY (user_id);
ALTER TABLE 2mr_events ADD PRIMARY KEY (event_id);
ALTER TABLE 2mr_medias ADD PRIMARY KEY (media_id);
ALTER TABLE 2mr_persons ADD PRIMARY KEY (person_id);
ALTER TABLE 2mr_trackings ADD UNIQUE KEY person_id (person_id,user_email);
ALTER TABLE 2mr_admins MODIFY user_id smallint(6) NOT NULL AUTO_INCREMENT;
ALTER TABLE 2mr_events MODIFY event_id smallint(5) NOT NULL AUTO_INCREMENT;
ALTER TABLE 2mr_medias MODIFY media_id smallint(5) NOT NULL AUTO_INCREMENT;
ALTER TABLE 2mr_persons MODIFY person_id smallint(5) NOT NULL AUTO_INCREMENT;