<?php
/*
    We all have that one file that contains all the configuration settings for the entire project.
    Well, we’ll begin by checking for the existence of that file. 
    That means we’ll consider the project as installed if the file exists on the server.
    Add this code at the beginning of your index.php to check it :

    <?php
    if (!file_exists( __DIR__ . '/config.php')) {   
        require_once __DIR__ . '/install.php';
        die();
    } else {
        require_once __DIR__ . '/config.php';
    }
    ?>
*/

if (!isset($_GET['lang'])) {
    $_GET['lang'] = 0;
}
$error = '';
if (isset($_POST['submit'])) {
    if ($_POST['title'] != '' && $_POST['description'] != '' && isset($_FILES['logo_file']['tmp_name']) && 
        $_FILES['logo_file']['name'] != '' && $_POST['fullurl'] != '' && $_POST['email'] != '' && $_POST['host'] != '' && 
        $_POST['username'] != '' && $_POST['password'] != '' && $_POST['db_name'] != '' && 
        $_POST['admin_name'] != '' && $_POST['admin_pass'] != '' && $_POST['admin_language'] != '' && $_POST['admin_mail'] != '') { 
        $db_error = false;
        $link      = mysqli_connect($_POST['host'], $_POST['username'], $_POST['password']);
        if (!@$link) {
            $db_error = true;
            $error = [  "Désolé, ces informations ne sont pas correctes.",
                        "Sorry, deze gegevens zijn niet correct.",
                        "Sorry, these details are not correct.",
                        "Siamo spiacenti, questi dati non sono corretti."][$_GET['lang']];
        }       
        if (!$db_error and !@mysqli_select_db($link, $_POST['db_name'])) {
            $sql = "CREATE DATABASE " . $_POST['db_name'];
            if (mysqli_query($link, $sql)) {
                mysqli_select_db($link, $_POST['db_name']);            
            } else {
                $db_error = true;
                $error = [  "L'hôte, le nom d'utilisateur et le mot de passe sont corrects.<br>Mais quelque chose ne va pas avec la base de données.",
                            "De host, gebruikersnaam en het wachtwoord zijn correct.<br>Maar er is iets mis met de gegeven database.",
                            "The host, username and password are correct.<br>But something is wrong with the given database.",
                            "L'host, il nome utente e la password sono corretti.<br>Ma c'è qualcosa che non va nel database dato."][$_GET['lang']];
            }
        }
        if (!$db_error) {
            copy($_FILES['logo_file']['tmp_name'], '../template/images/' . $_FILES['logo_file']['name']);
            $connect_code = "
<?php

/*
    " . $_POST['title'] . " : Database connexion and Initialisation
*/

define('HOST','" . $_POST['host'] . "');
define('USERNAME','" . $_POST['username'] . "');
define('PASSWORD','" . $_POST['password'] . "');
define('DB_NAME','" . $_POST['db_name'] . "');
\$link = mysqli_connect(HOST, USERNAME,PASSWORD,DB_NAME);
mysqli_select_db(\$link, DB_NAME);
mysqli_query(\$link, \"SET NAMES 'utf8'\");
mysqli_query(\$link, \"SET NAMES 'utf8' COLLATE 'utf8_unicode_ci'\");
mysqli_query(\$link, \"set global sql_mode='NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION'\");
if (!isset(\$admins_array)) {
\tforeach(mysqli_fetch_all(mysqli_query(\$link,\"SELECT user_id, user_admin, user_edit, user_name FROM 2mr_admins\")) as \$tmp) {
\t\t\$admins_array[\$tmp[0]] = \$tmp[1];
\t\t\$editors_array[\$tmp[0]] = \$tmp[2];
\t\t\$users_array[\$tmp[0]] = \$tmp[3];
\t}
}
\$site_url = '" . $_POST['fullurl'] . "';
\$site_name = '" . $_POST['title'] . "';
\$site_logo = '" . $_FILES['logo_file']['name'] . "';
\$site_mail = '" . $_POST['email'] . "';
\$site_desc = '" . $_POST['description'] . "';
?>";
            $fp = fopen('../includes/config.php', 'w');
            fwrite($fp, $connect_code);
            fclose($fp);
            // Import SQL FIle
            $filename = 'db.sql'; // $_FILES['logo']['name'];
            // Temporary variable, used to store current query
            $templine = '';
            // Read in entire file
            $lines = file($filename);
            // Loop through each line
            foreach ($lines as $line) {
                // Skip it if it's a comment
                if (substr($line, 0, 2) == '--' || $line == '') {
                    continue;
                }
                // Add this line to the current segment
                $templine .= $line;
                // If it has a semicolon at the end, it's the end of the query
                if (substr(trim($line), -1, 1) == ';') {
                    // Perform the query
                    if (!mysqli_query($link, $templine)) {
                        $error = [  "Erreur dans l'exécution de la requête", 
                                    "Fout bij het uitvoeren van query", 
                                    "Error performing query", 
                                    "Errore nell'esecuzione della query"][$_GET['lang']] . ' \'<strong>' . $templine . '\': ' . mysqli_error($link);
                    }
                    // Reset temp variable to empty
                    $templine = '';
                }
            }
            $admins = mysqli_fetch_array(mysqli_query($link, "SELECT table_name FROM information_schema.tables WHERE table_name LIKE '%_admins' AND table_type='BASE TABLE' AND table_schema = '" . $_POST['db_name'] . "'"))[0];
            $admin = "INSERT INTO " . $admins . " SET user_name = '" . $_POST['admin_name'] . "', user_password = '" . $_POST['admin_pass'] . "', user_email = '" . $_POST['admin_mail'] . "', user_language = '" . $_POST['admin_language'] . "', user_admin = 'Y', user_edit = 'Y'";
            if (!mysqli_query($link, $admin)) {
                $error = [  "Erreur dans l'exécution de la requête", 
                            "Fout bij het uitvoeren van query", 
                            "Error performing query", 
                            "Errore nell'esecuzione della query"][$_GET['lang']] . ' \'<strong>' . $admin . '\': ' . mysqli_error($link);                
            }
            header('location: ' . $_POST['fullurl']);
        }
    } else {
        $error = [  "Toutes les informations sont requises, désolé !",
                    "Alle informatie is vereist, sorry !",
                    "All information is required, sorry !",
                    "Tutte le informazioni sono obbligatorie, siamo spiacenti !"][$_GET['lang']];        
    }
}
?>


<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>
        <?php echo str_replace('§§',strtoupper(explode('/',$_SERVER['REQUEST_URI'])[1]),['Installation de §§','Installatie van §§','§§ Install','Installazione di '][$_GET['lang']]); ?>
    </title>
    <link rel="icon" type="image/x-icon" href="favicon.ico">
    <style>
        * {
            font-family: 'Work Sans', sans-serif;
            font-size:14px;
        }
        div {
            background-color: #ededed;
            border-radius: 5px;
            margin: auto;
            padding: 20px;
            width: 340px;
        }
        fieldset {
            margin-top: 1rem;
            text-align: right;
        }
        form {
            margin-top: 20px;
        }
        input[type=text], input[type=password], input[type=email], input[type=url], input[type=file], select {
            border-radius: 4px;
            border: 1px solid #ccc;
            box-sizing: border-box;
            display: inline-block;
            margin: 0.25rem 0 0rem 0;
            padding: 0.25rem 0.5rem;
            width: 100%;
        }
        input[type=submit] {
            background-color: #016a70;
            border-radius: 4px;
            border: none;
            color: white;
            cursor: pointer;
            padding: 14px 20px;
            width: 100%;
        }
        input[type=submit]:hover {
            background-color: #018c94;
        }
        label {
            float: left;
            margin-top: 0.5rem;
        }
        label:after {
            content: " :";
        }
        legend {
            font-size: 16px;
            padding: 0 0.5rem;
        }
        h3 {
            font-size: 20px;
            text-align: center;
            margin: 20px 0 10px 0;
            white-space: nowrap;
        }
        .logo {
            display: block;
            margin: 0 auto;
            width: fit-content;
        }
        #langs {
            float:right;
            line-height: 2rem;
        }
        .error {
            color: red; 
            display: block; 
            line-height: 1.4rem;
            min-height: 1rem;
            margin: 0.5rem auto; 
            width: fit-content; 
        }
    </style>
</head>
<body>

    <div>

        <img src="install/d0n_logo.png">

        <span id="langs">
            <a href="?lang=0">FR</a>&nbsp;|&nbsp;<a href="?lang=1">NL</a>&nbsp;|&nbsp;<a href="?lang=2">EN</a>&nbsp;|&nbsp;<a href="?lang=3">IT</a>
        </span>

        <h3>
            <?php echo ['Exécutez ce script pour installer', 'Voer dit script uit om te installeren', 'Run This Script To Install', 'Eseguite questo script per installare'][$_GET['lang']]; ?>
        </h3>
        <img src="install/script_logo.png" class="logo">

        <form action="?lang=<?php echo $_GET['lang']; ?>" method="post" enctype="multipart/form-data">

            <fieldset>

                <legend><?php echo ['Spécifications du site', 'Specificaties website ', 'Website Specifications', 'Specifiche del sito web'][$_GET['lang']]; ?></legend>

                <label for="title"><?php echo ['Titre', 'Titel', 'Title', 'Titolo'][$_GET['lang']]; ?></label>
                <input type="text" id="title" name="title" placeholder="<?php echo ['Mon premier site', 'Mijn eerste website', 'My First Site', 'Il mio primo sito web'][$_GET['lang']]; ?>"<?php echo (isset($_POST['title']) ? ' value="' . $_POST['title'] . '"':''); ?>>

                <label for="description"><?php echo ['Description', 'Beschrijving', 'Description', 'descrizione'][$_GET['lang']]; ?></label>
                <input type="text" id="description" name="description" placeholder="<?php echo ['Mon premier site', 'Mijn eerste website', 'My First Site', 'Il mio primo sito web'][$_GET['lang']]; ?>"<?php echo (isset($_POST['description']) ? ' value="' . $_POST['description'] . '"':''); ?>>

                <label for="logo_file"><?php echo ['Logo Site Web', 'Websitelogo', 'Logo Website', 'Logo del sito web'][$_GET['lang']]; ?></label>
                <input type="file" id="logo_file" name="logo_file" placeholder="logo.png">

                <label for="fullurl"><?php echo ['URL complète', 'Volledige URL van de site ', 'Full URL', 'URL completo'][$_GET['lang']]; ?></label>
                <input type="url" id="fullurl" name="fullurl" placeholder="<?php echo ['L\'adresse du site', 'Adres website', 'Site Adress', 'Indirizzo del sito web'][$_GET['lang']]; ?>"<?php echo (isset($_POST['fullurl']) ? ' value="' . $_POST['fullurl'] . '"':''); ?>>

                <label for="email"><?php echo ['Adresse de contact', 'Contactadres', 'Contact address', 'Indirizzo di contatto'][$_GET['lang']]; ?></label>
                <input type="email" id="email" name="email" placeholder="info@monsite.be"<?php echo (isset($_POST['email']) ? ' value="' . $_POST['email'] . '"':''); ?>>            

            </fieldset>

            <fieldset>

                <legend><?php echo ['Connexion au serveur', 'Serververbinding ', 'Server connection', 'Connessione al server'][$_GET['lang']]; ?></legend>
                <label for="host"><?php echo ['Hôte', 'Host', 'Host', 'Host'][$_GET['lang']]; ?></label>
                <input type="text" id="host" name="host" placeholder="localhost"<?php echo (isset($_POST['host']) ? ' value="' . $_POST['host'] . '"':''); ?>>

                <label for="username"><?php echo ['Utilisateur', 'Gebruiker ', 'Username', 'Nome utente'][$_GET['lang']]; ?></label>
                <input type="text" id="username" name="username" placeholder="<?php echo ['Nom de l\'utilisateur', 'Gebruikersnaam', 'Username', 'Nome utente'][$_GET['lang']]; ?>"<?php echo (isset($_POST['username']) ? ' value="' . $_POST['username'] . '"':''); ?>>

                <label for="password"><?php echo ['Mot de passe', 'Wachtwoord', 'Password', 'Password'][$_GET['lang']]; ?></label>
                <input type="password" id="password" name="password" placeholder="&lowast;&lowast;&lowast;&lowast;"<?php echo (isset($_POST['password']) ? ' value="' . $_POST['password'] . '"':''); ?>>
            
            </fieldset>

            <fieldset>

                <legend><?php echo ['Paramètres de la base de données', 'Database-instellingen', 'Database Settings', 'Impostazioni del database'][$_GET['lang']]; ?></legend>
                <label for="db_name"><?php echo ['Nom', 'Naam', 'Name', 'Nome'][$_GET['lang']]; ?></label>
                <input type="text" id="db_name" name="db_name" placeholder="<?php echo ['Ma base', 'Mijn database', 'My database', 'Il mio database'][$_GET['lang']]; ?>"<?php echo (isset($_POST['db_name']) ? ' value="' . $_POST['db_name'] . '"':''); ?>>

            </fieldset>

            <fieldset>

                <legend><?php echo ['Compte administrateur', '', 'Administrator Account', ''][$_GET['lang']]; ?></legend>
                <label for="admin_name"><?php echo ['Nom', 'Naam', 'Name', 'Nome'][$_GET['lang']]; ?></label>
                <input type="text" name="admin_name" placeholder="<?php echo ['Pseudo', '', '', ''][$_GET['lang']]; ?>"<?php echo (isset($_POST['admin_name']) ? ' value="' . $_POST['admin_name'] . '"':''); ?>>

                <label for="admin_pass"><?php echo ['Mot de passe', 'Wachtwoord', 'Password', 'Password'][$_GET['lang']]; ?></label>
                <input type="password" id="admin_pass" name="admin_pass" placeholder="&lowast;&lowast;&lowast;&lowast;"<?php echo (isset($_POST['admin_pass']) ? ' value="' . $_POST['admin_pass'] . '"':''); ?>>

                <label for="admin_language"><?php echo ['Langue', 'Taal', 'Language', 'Lingua'][$_GET['lang']]; ?></label>
                <select id="admin_language" name="admin_language">
                    <option value="FR"<?php echo (isset($_GET['lang']) && $_GET['lang'] == 0 ? ' selected':''); ?>>Français</option>
                    <option value="NL"<?php echo (isset($_GET['lang']) && $_GET['lang'] == 1 ? ' selected':''); ?>>Nederlands</option>
                    <option value="EN"<?php echo (isset($_GET['lang']) && $_GET['lang'] == 2 ? ' selected':''); ?>>English</option>
                    <option value="IT"<?php echo (isset($_GET['lang']) && $_GET['lang'] == 3 ? ' selected':''); ?>>Italiano</option>
                </select>

                <label for="admin_mail"><?php echo ['Adresse de courriel', 'E-mailadres', 'Email address', 'Indirizzo e-mail'][$_GET['lang']]; ?></label>
                <input type="email" id="admin_mail" name="admin_mail" placeholder="admin@monsite.be"<?php echo (isset($_POST['admin_mail']) ? ' value="' . $_POST['admin_mail'] . '"':''); ?>>

            </fieldset>

            <span class="error"><?php echo $error; ?></span>

            <input type="submit" name="submit" value="<?php echo ['Soumettre', 'Verzenden', 'Submit', 'Invia'][$_GET['lang']]; ?>">

        </form>

    </div>

</body>
</html>
